]> git.phdru.name Git - dotfiles.git/blob - .shellrc
bash: Cut long hostname to 5 characters
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 PS1="$OPS1$SHLVL "
19
20 if test -n "$BASH_VERSION"; then
21    # append to the history file, don't overwrite it
22    shopt -s histappend
23
24    # check the window size after each command and, if necessary,
25    # update the values of LINES and COLUMNS.
26    shopt -s checkwinsize
27
28    # If set, the pattern "**" used in a pathname expansion context will
29    # match all files and zero or more directories and subdirectories.
30    #shopt -s globstar
31 fi
32
33
34 #if [ -x /usr/bin/dircolors ]; then
35 #   # I don't like these aliases - they work only in command line
36 #   # but not in scripts I run from command line.
37 #   # Color parameters must be passed via environment.
38 #   # So instead I put them in shell scripts in ~/bin.
39 #   alias ls='ls --color=auto'
40 #   alias dir='dir --color=auto'
41 #   alias vdir='vdir --color=auto'
42 #
43 #   alias grep='grep --color=auto'
44 #   alias fgrep='fgrep --color=auto'
45 #   alias egrep='egrep --color=auto'
46 #
47 #   alias dmesg='dmesg --human'
48 #fi
49
50
51 case "$HOME" in
52    /home/*)
53       if [ -L /home ]; then
54          START_DIR="`pwd`" &&
55          cd "$HOME" &&
56          HOME="`pwd`" &&
57          cd "$START_DIR"
58       fi
59    ;;
60 esac
61
62
63 if test -n "$BASH_VERSION"; then
64    [ "`type -t ls`" = alias ] && unalias ls
65    [ "`type -t ll`" = alias ] && unalias ll
66    [ "`type -t mc`" = alias ] && unalias mc
67
68    back() { cd - "$@"; }
69    functions() { typeset -f "$@"; }
70    j() { jobs; }
71
72    has_completion() { return 0; }
73    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
74       if [ "$SHELL" = /bin/bash ]; then
75          if [ -d /usr/share/bash-completion -a -f /usr/share/bash-completion/bash_completion ]; then
76             . /usr/share/bash-completion/bash_completion
77             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
78          elif [ -f /etc/bash_completion ]; then
79             . /etc/bash_completion
80             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
81          elif [ -d /etc/bash_completion.d ]; then
82             for _compf in /etc/bash_completion.d/*; do
83                . $_compf
84             done
85             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
86          fi
87       elif [ "$SHELL" = /usr/local/bin/bash ]; then
88          if [ -d /usr/local/etc/bash_completion.d ]; then
89             for _compf in /usr/local/etc/bash_completion.d/*; do
90                . $_compf
91             done
92             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
93          fi
94       else
95          echo "Unknown OS type, cannot source bash_completion" >&2
96       fi
97    fi
98
99    for cmd in builtin cgmem_nice command dbus-launch exec \
100       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
101       time whence whereis which xargs; do
102          ! has_completion $cmd && complete -o default -A command $cmd
103    done
104
105    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
106       telnet t tt \
107       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
108       whois wd wget wget-download wget-m wget-wrapper ww; do
109          ! has_completion $cmd && complete -A hostname $cmd
110    done
111
112    for cmd in distribute ftp lftp r rsync \
113       s scp ssh smbclient tcpdump tshark wireshark; do
114          ! has_completion $cmd && complete -o default -A hostname $cmd
115    done
116
117    if [ -d "$HOME"/.bash_completion.d ]; then
118       for _compf in "$HOME"/.bash_completion.d/*; do
119          . $_compf
120       done
121    fi
122
123    delegate_completion() {
124       local prog programs
125       prog=$1
126       if has_completion $prog; then
127          shift
128          programs="$@"
129          eval "_${prog}_completion_loader() {
130             _completion_loader $prog
131             complete -o nospace -F _$prog $programs
132             unset _${prog}_completion_loader
133             return 124
134          }"
135          complete -F _${prog}_completion_loader $programs
136       fi
137    }
138
139    delegate_completion make m
140    delegate_completion ping p
141    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
142    delegate_completion ssh s
143    delegate_completion wget wget-m wget-wrapper ww
144
145    unset has_completion delegate_completion
146
147    complete -A job bg fg j jobs wait
148    complete -A variable -A function unset
149
150    if [ -d "$HOME/lib/config" ]; then
151       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
152    fi
153    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
154
155    if [ "`type -t short_curdir`" != function -a \
156          -r "$HOME"/admin/prog/short_curdir ]; then
157       . "$HOME"/admin/prog/short_curdir
158    fi
159
160    #if type -p pip >/dev/null 2>&1; then
161    #   eval "`pip completion --bash`"
162    #   rm -rf /tmp/pip_build_"$USER"
163    #fi
164
165    #if which pyenv >/dev/null 2>&1; then
166    #   eval "`pyenv init -`"
167    #   eval "`pyenv virtualenv-init -`"
168    #fi
169
170    . virtualenvwrapper_lazy.sh 2>/dev/null
171
172    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
173       . "$VIRTUAL_ENV/bin/activate"
174    fi
175
176    # Clean up python virtual environment on exit
177    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
178
179    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
180
181 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
182    back() { cd - "$@"; }
183    j() { jobs; }
184 fi
185
186
187 # clear screen and history, logout
188 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
189
190
191 if test -x /usr/bin/git >/dev/null 2>&1; then
192    # chdir to a directory
193    cdgitpath() {
194       if [ $# -ne 1 ]; then
195          echo "Usage: cdgitpath path_key" >&2
196          return 1
197       fi
198
199       path_key="$1"
200       if [ -z "$path_key" ]; then
201          echo "Usage: cdgitpath path_key" >&2
202          return 1
203       fi
204
205       path_url="`git config --get --path $path_key`"
206       if echo "$path_url" | grep -q '^file:/'; then
207          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
208       fi
209       cd "$path_url"
210    }
211
212    # chdir to a remote's directory (if the remote is on the local FS)
213    cdremote() {
214       if [ $# -gt 1 ]; then
215          echo "Usage: cdremote [remote_name]" >&2
216          return 1
217       fi
218
219       if [ -z "$1" ]; then
220          branch="`git rev-parse --abbrev-ref HEAD`"
221          remote="`git config --get branch.$branch.remote`"
222       else
223          remote="$1"
224       fi
225
226       if [ -n "$remote" ] && git config --get remote.$remote.url |
227             grep -q '^\(file:/\|/\|\.\./\)'; then # (file:/ or / or ../ at the beginning)
228          cdgitpath remote.$remote.url
229       else
230
231          if [ -n "$1" ]; then
232             echo "Cannot find directory for remote $1" >&2
233             echo "Usage: cdremote [remote_name]" >&2
234             return 1
235          fi
236
237          if test -n "$BASH_VERSION"; then
238             _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
239             if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
240                remote=${GIT_REMOTES[0]}
241                unset GIT_REMOTES
242                cdgitpath remote.$remote.url
243             else
244                unset GIT_REMOTES
245                echo "Cannot find directory for any remote" >&2
246                echo "Usage: cdremote [remote_name]" >&2
247                return 1
248             fi
249          else
250             echo "Cannot find directory for remote $1" >&2
251             echo "Usage: cdremote [remote_name]" >&2
252             return 1
253          fi
254       fi
255    }
256
257    if test -n "$BASH_VERSION"; then
258       # completion for aliases in global .gitconfig
259
260       # fixup rbi rbia rbiap rbip - do refs name completion
261       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
262       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
263       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
264       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
265       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
266       #
267       # push-to-all-remotes - do branch name completion
268       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
269
270       _cdgitpath_complete() {
271          local cur="${COMP_WORDS[COMP_CWORD]}"
272          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
273       }
274
275       _git_open() {
276          _cdgitpath_complete
277       }
278
279       complete -F _cdgitpath_complete cdgitpath git-open
280
281       # list remotes with URLs matching a regexp
282       _list_remotes() {
283          if [ $# -ne 1 ]; then
284             echo "Usage: _list_remotes remote_regexp" >&2
285             return 1
286          fi
287          declare -ag GIT_REMOTES=()
288          local remote
289          for remote in `git remote`; do
290             if git config --get remote.$remote.url | grep -q "$1"; then
291                GIT_REMOTES+=($remote)
292             fi
293          done
294       }
295
296       # completion for cdremote and git-open-remote - list remotes with a pattern
297       _list_remotes_completion() {
298          local cur="${COMP_WORDS[COMP_CWORD]}"
299          _list_remotes "$1"
300          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
301          unset GIT_REMOTES
302       }
303
304       # completion for cdremote - list remotes with directories as URLs
305       _cdremote_complete() {
306          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
307          if [ ${#COMPREPLY[*]} -eq 0 ]; then
308             _list_remotes_completion .
309          fi
310       }
311
312       complete -F _cdremote_complete cdremote
313
314       # completion for git-open-remote - list remotes with http(s) URLs
315       _git_open_remote() {
316          _list_remotes_completion '^http\(s\)\?://'
317          if [ ${#COMPREPLY[*]} -eq 0 ]; then
318             _list_remotes_completion .
319          fi
320       }
321
322       complete -F _git_open_remote git-open-remote
323    fi
324 fi
325
326
327 include() {
328    cfg="$1"
329    if [ -f "./$cfg" -a -r "./$cfg" ]; then
330       echo "Reading config file \`$cfg'" 1>&2
331       . "./$cfg"
332    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
333       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
334       . "$HOME/lib/config/$cfg"
335    else
336       echo "Cannot find config file \`$cfg'" 1>&2
337    fi
338 }
339
340
341 mc() {
342    if test -n "$BASH_VERSION"; then
343       MC_SAVE_OPS1="$OPS1"
344       if [ "`type -t short_curdir`" = function ]; then
345          OPS1="\u@\${HOSTNAME::5} \`short_curdir\` \\$"
346       else
347          OPS1="\u@\h \W \\$"
348       fi
349    fi
350
351    if [ -n "$SLOWTERM" ]; then
352       MC_SLOW="--slow"
353    fi
354
355    case "$TERM" in
356       screen*) # screen, screen.rxvt
357          MC_XTERM="-x"
358       ;;
359    esac
360
361    #TMPDIR="$HOME"/tmp
362    #export TMPDIR
363
364    MC_FOUND=NO
365
366    for wrapper in \
367          /usr/local/share/mc/bin/mc-wrapper.sh \
368          /usr/local/libexec/mc/mc-wrapper.sh \
369          /usr/share/mc/bin/mc-wrapper.sh; do
370       if [ -r $wrapper ]; then
371          . $wrapper $MC_SLOW $MC_XTERM "$@"
372          rc=$?
373          MC_FOUND=YES
374          break
375       fi
376    done
377
378    if [ $MC_FOUND = NO ]; then
379       for mc in /usr/local/bin/mc /usr/bin/mc; do
380          if [ -x $mc ]; then
381             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
382             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
383                MC_TMP_DIR="${TMPDIR-/tmp}"
384             fi
385             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
386             mc_type="`mc_type.py $mc`"
387             if [ "$mc_type" = old ]; then
388                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
389             elif [ "$mc_type" = new ]; then
390                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
391             else
392                continue
393             fi
394             rc=$?
395             MC_FOUND=YES
396             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
397             break
398          fi
399       done
400    fi
401
402    if [ $MC_FOUND = NO ]; then
403       echo "Cannot find mc-wrapper.sh or mc" >&2
404       rc=1
405    fi
406
407    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
408    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
409
410    return $rc
411 }
412
413
414 mkcd() {
415    if [ $# -ne 1 ]; then
416       echo "Usage: mkcd directory_name" >&2
417    elif [ -d "$1" ]; then
418       cd "$1"
419    elif [ -e "$1" ]; then
420       echo "Error: $1 is a file" >&2
421    else
422       mkdir -p "$1" && cd "$1"
423    fi
424 }
425
426
427 if which tmux >/dev/null 2>&1; then
428    tmux() {
429       case "$TERM" in
430          rxvt)
431             TERM=rxvt-unicode command tmux "$@"
432          ;;
433
434          *)
435             command tmux "$@"
436          ;;
437       esac
438    }
439 fi
440
441
442 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
443    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
444 fi
445
446 x() { exit; }